﻿using LawFirmContracts.BusinessLogicsContracts;
using LawFirmContracts.ViewModels;
using LawFirmDataModels.Models;

namespace LawFirmView
{
    public partial class FormDocumentBlank : Form
    {
        private readonly List<BlankViewModel>? _list;
        public int Id
        {
            get
            {
                return Convert.ToInt32(comboBoxBlank.SelectedValue);
            }
            set
            {
                comboBoxBlank.SelectedValue = value;
            }
        }
        public IBlankModel? BlankModel
        {
            get
            {
                if (_list == null)
                {
                    return null;
                }
                foreach (var elem in _list)
                {
                    if (elem.Id == Id)
                    {
                        return elem;
                    }
                }
                return null;
            }
        }
        public int Count
        {
            get { return Convert.ToInt32(textBoxCount.Text); }
            set{ textBoxCount.Text = value.ToString(); }
        }
        public FormDocumentBlank(IBlankLogic logic)
        {
            InitializeComponent();

            _list = logic.ReadList(null);
            if (_list != null)
            {
                comboBoxBlank.DisplayMember = "BlankName";
                comboBoxBlank.ValueMember = "Id";
                comboBoxBlank.DataSource = _list;
                comboBoxBlank.SelectedItem = null;
            }
        }
        private void ButtonSave_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBoxCount.Text))
            {
                MessageBox.Show("Заполните поле Количество", "Ошибка",
               MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (comboBoxBlank.SelectedValue == null)
            {
                MessageBox.Show("Выберите компонент", "Ошибка",
               MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            DialogResult = DialogResult.OK;
            Close();
        }
        private void ButtonCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }
    }
}
